﻿using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Drawing;
using System.Linq;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;

namespace SharedWorkflows
{
  public sealed partial class IfElseCodeWorkflow : SequentialWorkflowActivity
  {

    #region TestNumber dependency property

    /// <summary>
    /// A number to test.
    /// </summary>
    public static readonly DependencyProperty TestNumberProperty;


    /// <summary>
    /// A property wrapper for the <see cref="TestNumberProperty"/>
    /// dependency property:<br/>
    /// A number to test.
    /// </summary>
    [Description("A number to test.")]
    [Category("Flow Control")]
    [Browsable(true)]
    [DesignerSerializationVisibility(DesignerSerializationVisibility.Visible)]
    [DefaultValue(-1)]
    public int TestNumber
    {
      get { return (int)GetValue(TestNumberProperty); }
      set { SetValue(TestNumberProperty, value); }
    }

    #endregion


    static IfElseCodeWorkflow()
    {
      //register dependency property
      PropertyMetadata md = new PropertyMetadata(-1);
      TestNumberProperty = DependencyProperty.Register("TestNumber", typeof(int), typeof(IfElseCodeWorkflow), md);
    }

    public IfElseCodeWorkflow()
    {
      InitializeComponent();
    }


    private void GetTestNumber(object sender, EventArgs e)
    {
      Console.Out.WriteLine("Please insert test number (positive, negative, or zero).");
      Console.Out.WriteLine("A negative value will cause a console output.");
      Console.Out.WriteLine("A positive value will cause a debug output (not on console).");
      Console.Out.WriteLine("A value of zero will run silently through the assertion.");
      Console.Out.WriteLine("A value of 1 will trigger an assertion output because it violates the assertion condition.");
      Console.Out.WriteLine("->Note that both 0/1 trigger the zero-branch (with 1 triggering the assertion).\n");
      string input = Console.ReadLine();
      TestNumber = int.Parse(input);
    }

  }

}
