using System;
using System.Workflow.Runtime;

namespace Hardcodet.WF.Util.Hosting
{
  /// <summary>
  /// Event arguments for events related to a given workflow runtime.
  /// </summary>
  public class WorkflowRuntimeEventArgs : EventArgs
  {
    /// <summary>
    /// The underlying workflow runtime that caused the event.
    /// </summary>
    public WorkflowRuntime Runtime { get; private set; }

    /// <summary>
    /// Indicates whether the <see cref="Runtime"/> was started when the
    /// event was raised.
    /// </summary>
    /// <remarks>You may also check the <see cref="WorkflowRuntime.IsStarted"/>
    /// method to get the current status.</remarks>
    public bool IsStarted { get; set; }


    public WorkflowRuntimeEventArgs(WorkflowRuntime runtime, bool isStarted)
    {
      Runtime = runtime;
      IsStarted = isStarted;
    }
  }
}