﻿using System;
using System.Collections.ObjectModel;

namespace Hardcodet.WF.Util.Hosting
{
  /// <summary>
  /// Stores <see cref="WorkflowInstanceWrapper"/> objects by the unique
  /// IDs of the wrapped workflow instances.
  /// </summary>
  public class WorkflowWrapperCollection : KeyedCollection<Guid, WorkflowInstanceWrapper>
  {
    protected override Guid GetKeyForItem(WorkflowInstanceWrapper item)
    {
      return item.WorkflowInstance.InstanceId;
    }
  }
}